OGRE: Ogre::RegionSceneQuery Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::RegionSceneQuery Class Referenceabstract
Core » Scene

Abstract class defining a query which returns single results from a region. More...

`#include <OgreSceneQuery.h>`

Inheritance diagram for Ogre::RegionSceneQuery:
[legend]

## Public Member Functions
| RegionSceneQuery (SceneManager *mgr)
| Standard constructor, should be called by SceneManager.
virtual | ~RegionSceneQuery ()
void | clearResults (void)
| Clears the results of the last query execution.
virtual void | execute (SceneQueryListener *listener)=0
| Executes the query and returns each match through a listener interface.
virtual SceneQueryResult & | execute (void)
| Executes the query, returning the results back in one list.
const SceneQueryResult & | getLastResults (void) const
| Gets the results of the last query that was run using this object, provided the query was executed using the collection-returning version of execute.
bool | queryResult (MovableObject *first) override
| Self-callback in order to deal with execute which returns collection.
bool | queryResult (SceneQuery::WorldFragment *fragment) override
| Self-callback in order to deal with execute which returns collection.
Public Member Functions inherited from Ogre::SceneQuery
| SceneQuery (SceneManager *mgr)
| Standard constructor, should be called by SceneManager.
virtual | ~SceneQuery ()
virtual uint32 | getQueryMask (void) const
| Returns the current mask for this query.
virtual uint32 | getQueryTypeMask (void) const
| Returns the current mask for this query.
virtual void | setQueryMask (uint32 mask)
| Sets the mask for results of this query.
virtual void | setQueryTypeMask (uint32 mask)
| Sets the type mask for results of this query.
Public Member Functions inherited from Ogre::SceneQueryListener
virtual | ~SceneQueryListener ()

## Additional Inherited Members
Public Types inherited from Ogre::SceneQuery
typedef Ogre::WorldFragment | WorldFragment

## Detailed Description

Abstract class defining a query which returns single results from a region.

This class is simply a generalisation of the subtypes of query that return a set of individual results in a region. See the SceneQuery class for abstract information, and subclasses for the detail of each query type.

## Constructor & Destructor Documentation

## ◆ RegionSceneQuery()

Ogre::RegionSceneQuery::RegionSceneQuery | ( | SceneManager * | mgr | ) |

Standard constructor, should be called by SceneManager.

## ◆ ~RegionSceneQuery()

virtual Ogre::RegionSceneQuery::~RegionSceneQuery | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ execute() [1/2]

virtual SceneQueryResult & Ogre::RegionSceneQuery::execute | ( | void |  | ) |
| virtual

Executes the query, returning the results back in one list.

This method executes the scene query as configured, gathers the results into one structure and returns a reference to that structure. These results will also persist in this query object until the next query is executed, or clearResults() is called. An more lightweight version of this method that returns results through a listener is also available.

## ◆ execute() [2/2]

virtual void Ogre::RegionSceneQuery::execute | ( | SceneQueryListener * | listener | ) |
| pure virtual

Executes the query and returns each match through a listener interface.

Note that this method does not store the results of the query internally so does not update the 'last result' value. This means that this version of execute is more lightweight and therefore more efficient than the version which returns the results as a collection.

Implemented in Ogre::DefaultAxisAlignedBoxSceneQuery, Ogre::DefaultPlaneBoundedVolumeListSceneQuery, Ogre::DefaultSphereSceneQuery, Ogre::OctreeAxisAlignedBoxSceneQuery, Ogre::OctreePlaneBoundedVolumeListSceneQuery, Ogre::OctreeSphereSceneQuery, Ogre::PCZAxisAlignedBoxSceneQuery, Ogre::PCZPlaneBoundedVolumeListSceneQuery, and Ogre::PCZSphereSceneQuery.

## ◆ getLastResults()

const SceneQueryResult & Ogre::RegionSceneQuery::getLastResults | ( | void |  | ) | const

Gets the results of the last query that was run using this object, provided the query was executed using the collection-returning version of execute.

## ◆ clearResults()

void Ogre::RegionSceneQuery::clearResults | ( | void |  | ) |

Clears the results of the last query execution.

You only need to call this if you specifically want to free up the memory used by this object to hold the last query results. This object clears the results itself when executing and when destroying itself.

## ◆ queryResult() [1/2]

bool Ogre::RegionSceneQuery::queryResult | ( | MovableObject * | first | ) |
| overridevirtual

Self-callback in order to deal with execute which returns collection.

Implements Ogre::SceneQueryListener.

## ◆ queryResult() [2/2]

bool Ogre::RegionSceneQuery::queryResult | ( | SceneQuery::WorldFragment * | fragment | ) |
| overridevirtual

Self-callback in order to deal with execute which returns collection.

Reimplemented from Ogre::SceneQueryListener.

The documentation for this class was generated from the following file:

- OgreSceneQuery.h